<?php
/*
Plugin Name: Simple Flash Video
Version: 1.4
Plugin URI: http://www.simplethoughtproductions.com/category/simple-flash-video/
Description: Allows the addition of FLV and MP4 video to blog posts powered by Jeroen Wijering's FLV Media Player, SWFObject by Geoff Stearns, and Shadowbox by Michael J. I. Jackson
Author: Josh Chesarek & Daniel G. Taylor
Author URI: http://www.simplethoughtproductions.com

Copyright Josh Chesarek & Daniel G. Taylor 2008

This file is part of Simple Flash Video.

    Simple Flash Video is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 2 of the License, or
    (at your option) any later version.

    Simple Flash Video is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
    
    
    Software used or referenced in the making of this plugin:
    
    JW FLV Player - http://www.jeroenwijering.com/?item=JW_FLV_Media_Player
    Shadowbox - http://jquery.com/demo/thickbox/
    Flash Video Player Plugin for Wordpress - http://www.mac-dev.net/blog/index.php
    
*/
if (!class_exists("SimpleFlashVideoPlugin"))
{
    class SimpleFlashVideoPlugin 
    {
        
        function SimpleFlashVideoPlugin() { //constructor
           
    }
        
        function init() 
        {
			//nothing to do yet
        }
        
        //Headers!
   		function addHeaderCode() 
   		{
   			global $site_url;
            ?>
				 

<script type="text/javascript" src= "<?php echo $site_url ?>/wp-content/plugins/simple-flash-video/shadowbox-jquery.js"></script>
<script type="text/javascript" src="<?php echo $site_url ?>/wp-content/plugins/simple-flash-video/shadowbox.js"></script>
<link rel="stylesheet" href="<?php echo $site_url ?>/wp-content/plugins/simple-flash-video/shadowbox.css" type="text/css" media="screen" />
<script type="text/javascript" src="<?php echo $site_url ?>/wp-content/plugins/simple-flash-video/swfobject.js"></script>
<script type="text/javascript" src="<?php echo $site_url ?>/wp-content/plugins/simple-flash-video/yui-utilities.js"></script>
<script type="text/javascript" src="<?php echo $site_url ?>/wp-content/plugins/simple-flash-video/shadowbox-yui.js"></script>
<script type="text/javascript" src="<?php echo $site_url ?>/wp-content/plugins/simple-flash-video/shadowbox.js"></script>
<script type="text/javascript">window.onload = function(){

	 var options = {
        resizeLgImages:     true,
        autoplayMovies:     false,
        animSequence: 		"sync",
        loadingImage:       "<?php echo $site_url ?>/wp-content/plugins/simple-flash-video/loadingAnimation.gif"
        
    };


    Shadowbox.init(options);

};
</script>
            <?php
       
        }
   
   		 			
 }
 
 //Global Variables 
 $videoid = 1;
 $arr = array();
 $cur_tag = "";
 $site_url = get_option('siteurl');

function start_el_handler($parser,$name,$attribs)
				{
				    global $cur_tag;
				    $cur_tag = $name;
				}
function end_el_handler($parser,$name){}
function char_handler($parser,$data) {
				    global $cur_tag, $arr;
				    $arr[$cur_tag] .= trim($data);
				}
 
 function getAdminOptions()
 {
 	global $arr;
 			$arr = array();
 					//Read in the Config XML to get the Default Height and Width of the Video		
   		   		$config_file_xml = dirname(__FILE__) . "/config.xml";
   		   		$xml = file_get_contents($config_file_xml) or die("Can't open remote files!");
				
				$parser = xml_parser_create();
				xml_set_element_handler($parser, "start_el_handler", 'end_el_handler');
				xml_set_character_data_handler($parser, "char_handler");
				xml_parse($parser,$xml);
	return $arr;
 	
 }
 
 function getURL()
 {
 	$parts = explode("?", $_SERVER["REQUEST_URI"]);
    $request = $parts[0];
    if (substr($request, strlen($request) - 3, 3) == "php")
    {
        $parts = explode("/", $request);
        $request = implode("/", array_slice($parts, 0, sizeof($parts) - 1));
    }
    if (substr($request, strlen($request) - 1, 1) == '/')
    {
        $request = substr($request, 0, strlen($request) - 1);
    }
    
 }
 
 function printAdminPage() 
			{				

				$sfvOptions = getAdminOptions();
				
				if (isset($_POST['update_SimpleFlashVideoSettings']))
				{
					$sfvOptions['HEIGHT'] = $_POST['vid_height'];
					$sfvOptions['WIDTH'] = $_POST['vid_width'];
					$sfvOptions['IMAGE'] = $_POST['image'];
					$sfvOptions['CONTROLBAR'] = $_POST['controlbar'];
					$sfvOptions['SKIN'] = $_POST['skin'];
					$sfvOptions['LOGO'] = $_POST['logo'];
					$sfvOptions['PLAYLIST'] = $_POST['playlist'];
					$sfvOptions['PLAYLISTSIZE'] = $_POST['playlistsize'];
					$sfvOptions['CAPTIONS'] = $_POST['captions'];
					$sfvOptions['DISPLAYCLICK'] = $_POST['displayclick'];
					$sfvOptions['MUTE'] = $_POST['mute'];
					$sfvOptions['QUALITY'] = $_POST['quality'];
					$sfvOptions['LINKTARGET'] = $_POST['linktarget'];
					$sfvOptions['STRETCHING'] = $_POST['stretching'];
					$sfvOptions['FULLSCREEN'] = $_POST['fullscreen'];
					$sfvOptions['BUFFERLENGTH'] = $_POST['bufferlength'];
					$sfvOptions['STREAMSCRIPT'] = $_POST['streamscript'];
					$sfvOptions['FALLBACK'] = $_POST['fallback'];
					$sfvOptions['REPEAT'] = $_POST['repeat'];
					$sfvOptions['VOLUME'] = $_POST['volume'];
					$sfvOptions['SHUFFLE'] = $_POST['shuffle'];
					
					//Write the settings to config.xml
					$config_file_xml = dirname(__FILE__) . "/config.xml";
					$fh = fopen($config_file_xml, 'w') or die("can't open file");
					$xml = "<?xml version=\"1.0\"?>\n\n<config>\n";
					foreach ($sfvOptions as $key => $value)
					{
						if ($key != "CONFIG")
						{
							if ($value != "")
							$xml .= "\t<" . strtolower($key) . ">" . $value . "</" . strtolower($key) . ">\n";
						}
					}
					$xml .= "</config>\n";
					fwrite($fh, $xml);
					fclose($fh);
										
				}
				
				?>
				<div class=wrap>
				<form method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>">
				<h2>Simple Flash Video Plugin Settings fron config.xml</h2>
				<h3>Height of video:</h3>
				<textarea name="vid_height" style="width: 20%; height: 15px;"><?php echo $sfvOptions['HEIGHT']?></textarea>
				<h3>Width of video:</h3>	
				<textarea name="vid_width" style="width: 20%; height: 15px;"><?php echo $sfvOptions['WIDTH']?></textarea>
				<h3>Default Volume:</h3>	
				<textarea name="volume" style="width: 20%; height: 15px;"><?php echo $sfvOptions['VOLUME']?></textarea>
				<h3>Skin of player:</h3>	
				<textarea name="skin" style="width: 20%; height: 15px;"><?php echo $sfvOptions['SKIN']?></textarea>
				
				<h3>Controlbar Location:</h3>
				<p><label for="controlbar_bottom"><input type="radio" id="controlbar_bottom" name="controlbar" value="bottom" <?php if ($sfvOptions['CONTROLBAR'] == "bottom") { _e('checked="checked"'); }?>/> Bottom of video</label>&nbsp;&nbsp;&nbsp;&nbsp;<label for="controlbar_over"><input type="radio" id="controlbar_over" name="controlbar" value="over" <?php if ($sfvOptions['CONTROLBAR'] == "over") { _e('checked="checked"'); }?>/> Over the Video</label>&nbsp;&nbsp;&nbsp;&nbsp;<label for="controlbar_none"><input type="radio" id="controlbar_none" name="controlbar" value="none" <?php if ($sfvOptions['CONTROLBAR'] == "none") { _e('checked="checked"'); }?>/> Do not display Controlbar</label>&nbsp;&nbsp;&nbsp;&nbsp;</p>
				
				
				<h3>Playlist Location:</h3>
				<p><label for="playlist_bottom"><input type="radio" id="playlist_bottom" name="playlist" value="bottom" <?php if ($sfvOptions['PLAYLIST'] == "bottom") { _e('checked="checked"'); }?>/> Bottom of video</label>&nbsp;&nbsp;&nbsp;&nbsp;<label for="playlist_over"><input type="radio" id="playlist_over" name="playlist" value="over" <?php if ($sfvOptions['PLAYLIST'] == "over") { _e('checked="checked"'); }?>/> Over the Video</label>&nbsp;&nbsp;&nbsp;&nbsp;<label for="playlist_right"><input type="radio" id="playlist_right" name="playlist" value="right" <?php if ($sfvOptions['PLAYLIST'] == "right") { _e('checked="checked"'); }?>/> Right of the Video</label>&nbsp;&nbsp;&nbsp;&nbsp;<label for="playlist_none"><input type="radio" id="playlist_none" name="playlist" value="none" <?php if ($sfvOptions['PLAYLIST'] == "none") { _e('checked="checked"'); }?>/> Do not display Playlist</label></p>
				
				<h3>Size of Playlist in Pixels:</h3>	
				<textarea name="playlistsize" style="width: 20%; height: 15px;"><?php echo $sfvOptions['PLAYLISTSIZE']?></textarea>
					
				<h3>Quality</h3>
				<p><label for="quality_true"><input type="radio" id="quality_true" name="quality" value="true" <?php if ($sfvOptions['QUALITY'] == "true") { _e('checked="checked"'); }?>/> True(Helps videos look better but uses more CPU)</label>&nbsp;&nbsp;&nbsp;&nbsp;<label for="quality_false"><input type="radio" id="quality_false" name="quality" value="false" <?php if ($sfvOptions['QUALITY'] == "false") { _e('checked="checked"'); }?>/> False(Uses Less CPU better if you have high CPU)</label></p>
				
				<h3>Mute by Default</h3>
				<p><label for="mute_true"><input type="radio" id="mute_true" name="mute" value="true" <?php if ($sfvOptions['MUTE'] == "true") { _e('checked="checked"'); }?>/> True</label>&nbsp;&nbsp;&nbsp;&nbsp;<label for="mute_false"><input type="radio" id="mute_false" name="mute" value="false" <?php if ($sfvOptions['MUTE'] == "false") { _e('checked="checked"'); }?>/> False</label></p>
				
				<h3>URL of Logo to place at top right corner of all videos:</h3>	
				<textarea name="logo" style="width: 50%; height: 15px;"><?php echo $sfvOptions['LOGO']?></textarea>
				
				<h3>Link to Image to display before any video starts:</h3>
				<textarea name="video_width" style="width: 50%; height: 15px;"><?php echo $sfvOptions['IMAGE']?></textarea>
				
				<h3>Stretching</h3>
				<p><label for="stretching_true"><input type="radio" id="stretching_none" name="stretching" value="none" <?php if ($sfvOptions['STRETCHING'] == "none") { _e('checked="checked"'); }?>/> None</label>&nbsp;&nbsp;&nbsp;&nbsp;<label for="stretching_exactfit"><input type="radio" id="stretching_exactfit" name="stretching" value="exactfit" <?php if ($sfvOptions['STRETCHING'] == "exactfit") { _e('checked="checked"'); }?>/> exactfit</label>&nbsp;&nbsp;&nbsp;&nbsp;<label for="stretching_uniform"><input type="radio" id="stretching_uniform" name="stretching" value="uniform" <?php if ($sfvOptions['STRETCHING'] == "uniform") { _e('checked="checked"'); }?>/> Uniform</label>&nbsp;&nbsp;&nbsp;&nbsp;<label for="stretching_fill"><input type="radio" id="stretching_fill" name="stretching" value="fill" <?php if ($sfvOptions['STRETCHING'] == "fill") { _e('checked="checked"'); }?>/> fill</label></p>
								
				<h3>Allow Fullscreen</h3>
				<p><label for="fullscreen_true"><input type="radio" id="fullscreen_true" name="fullscreen" value="true" <?php if ($sfvOptions['FULLSCREEN'] == "true") { _e('checked="checked"'); }?>/> True</label>&nbsp;&nbsp;&nbsp;&nbsp;<label for="fullscreen_false"><input type="radio" id="fullscreen_false" name="fullscreen" value="false" <?php if ($sfvOptions['FULLSCREEN'] == "false") { _e('checked="checked"'); }?>/> False</label></p>
				
				<h3>Buffer Length</h3>
				<textarea name="bufferlength" style="width: 20%; height: 15px;"><?php echo $sfvOptions['BUFFERLENGTH']?></textarea>				
				
				<h3>Stream Script to use:</h3>	
				<textarea name="streamscript" style="width: 50%; height: 15px;"><?php echo $sfvOptions['STREAMSCRIPT']?></textarea>
				
				<h3>Fallback flv to use when viewer cannot play .mp4:</h3>	
				<textarea name="fallback" style="width: 50%; height: 15px;"><?php echo $sfvOptions['FALLBACK']?></textarea>
				
				<h3>Repeat Playback</h3>
				<p><label for="repeat_true"><input type="radio" id="repeat_true" name="repeat" value="true" <?php if ($sfvOptions['REPEAT'] == "true") { _e('checked="checked"'); }?>/> True</label>&nbsp;&nbsp;&nbsp;&nbsp;<label for="repeat_false"><input type="radio" id="repeat_false" name="repeat" value="false" <?php if ($sfvOptions['REPEAT'] == "false") { _e('checked="checked"'); }?>/> False</label>&nbsp;&nbsp;&nbsp;&nbsp;<label for="repeat_list"><input type="radio" id="repeat_list" name="repeat" value="list" <?php if ($sfvOptions['REPEAT'] == "list") { _e('checked="checked"'); }?>/> List</label></p>
				
				<h3>Shuffle on playlists</h3>
				<p><label for="shuffle_true"><input type="radio" id="shuffle_true" name="shuffle" value="true" <?php if ($sfvOptions['SHUFFLE'] == "true") { _e('checked="checked"'); }?>/> True</label>&nbsp;&nbsp;&nbsp;&nbsp;<label for="shuffle_false"><input type="radio" id="shuffle_false" name="shuffle" value="false" <?php if ($sfvOptions['SHUFFLE'] == "false") { _e('checked="checked"'); }?> /> False</label></p>
				
				<div class="submit">
				<input type="submit" name="update_SimpleFlashVideoSettings" value="Save Changes Yo!" /></div>
				</form>
 				</div>

 				
					<?php
				}//End function printAdminPage()				
			
				
 //Find the Sections of the post that need to be replaced - *Flash Video Player Code*
 function FlashVideo_Parse($content) 
 	{
		$content = preg_replace_callback("/\[video ([^]]*)\/\]/i", "FlashVideo_Render", $content);
		return $content;
	}
 	
 
//Replace all the post entries with videos
 function FlashVideo_Render($matches) 
		{
			global $site_url;
			global $videoid;
			
			 //More Voodoo - *Flash Video Player Code*
			$matches[1] = str_replace(array('&#8221;','&#8243;'), '', $matches[1]);
			preg_match_all('/(\w*)=(.*?) /i', $matches[1], $attributes);
			$arguments = array();

			//Put all of the arguments into an array
			foreach ( (array) $attributes[1] as $key => $value ) 
			{
			// Strip out legacy quotes
			$arguments[$value] = str_replace('"', '', $attributes[2][$key]);
			}
	
			//If no file name is provided put an error in the post *Flash Video Player Code*
			if ( !array_key_exists('filename', $arguments) )
			{
				return '<div style="background-color:#f99; padding:10px;">Error: Required parameter "filename" is missing!</div>';
				exit;
			}
	
	
			//set output to nothing
			$output = '';
			
			//settings that we do not want passed through to the video.php
			$plugin_settings = array("shadowbox", "filename");
			
   		    //Get Setings
   		    $sfvOptions = getAdminOptions();
   		    				
     		$height = $sfvOptions['HEIGHT'];
     		$width = $sfvOptions['WIDTH'];
     		     		
     		
			//Get the file name of the picture to use if it exists
			$parts = pathinfo($arguments['filename']);
			$thumb = $parts["dirname"] . "/" . substr($parts["basename"], 0, strlen($parts["basename"]) - strlen($parts["extension"])) . "jpg";
	
			//Setup the output as all of them start the same
			$output .= "\n" . '<a href="' . $site_url . '/wp-content/plugins/simple-flash-video/video.php?height=';
	
			//The User turned off shadowbox, just post the video
			if (array_key_exists('shadowbox', $arguments) )
			{
		 		if ($arguments['shadowbox'] == 'off')
		 		{		 			
		 			//ReSetup the output as all of them start the same
					$output ='';
					
					//Write the video player using the provided and the config.xml variables 
					$output .= "\n" . '<span id="sfvcontainer' . $videoid . '" class="flashvideo">' . "\n";
					$output .= '<a href="http://www.macromedia.com/go/getflashplayer">Get the Flash Player</a> to see this player.</span>' . "\n";
					$output .= '<script type="text/javascript">' . "\n";
					$output .= 'var s' . $videoid . ' = new SWFObject("' . $site_url . '/wp-content/plugins/simple-flash-video/mediaplayer.swf' . '","sfvideo' . $videoid . '","'; 
			
					//Check to see if new width has been given, if not use default
					if ( array_key_exists('width', $arguments) )
		 			{
						if ($arguments['width'] != $width) 
						{
							$output .= $arguments['width']; 
						}
					}
		 
					else
					{
	 					$output .= $width;
					}	
			
					//Check to see if a new height has been given, if not use default
					if ( array_key_exists('height', $arguments) )
					 {
						if ($arguments['height'] != $height) 
						{
							$output .= '","' . $arguments['height'];
						}
					 }
			
					else
					{
	 					$output .= '","' .  $height; 
					}
				
					$output .= '","7");' . "\n";
					$output .= 's' . $videoid . '.addParam("allowfullscreen","true");' . "\n";
					$output .= 's' . $videoid . '.addParam("allowscriptaccess","always");' . "\n";
					$output .= 's' . $videoid . '.addVariable("file", "' . $arguments['filename'] . '");' . "\n";
					$output .= 's' . $videoid . '.addVariable("config", "' . $site_url . '/wp-content/plugins/simple-flash-video/config.xml");' . "\n";
					if ($arguments['height'] != "")
					{ 
						$output .= 's' . $videoid . '.addVariable("height", "' . $arguments['height'] . '");' . "\n";
					}
					if ($arguments['width'] != "")
					{
						$output .= 's' . $videoid . '.addVariable("width", "' . $arguments['width'] . '");' . "\n";
					}
					foreach($arguments as $name => $value)
					{
						if (array_search($name, $plugin_settings) === false)
						{
					    	$output .= 's' . $videoid . '.addVariable("'. $name . '", "' . $value . '");' . "\n";
						}
					}
					$output .= 's' . $videoid . '.write("sfvcontainer' . $videoid . '");' . "\n";
					$output .= '</script></center>' . "\n";
					
					$videoid += 1;
		 		}
		
			}
		
			//Shadowbox is on!
			if (!array_key_exists('shadowbox', $arguments) )
			{				
		 
				//If there is a picture use it
				if (file_exists ($_SERVER['DOCUMENT_ROOT'] . $thumb))
				{
					//	The user wants to use a custom height and width, use the passed values
					if ( array_key_exists('height', $arguments) )
				 	{
		 	 			 //Set padding for the width to allow Shadowbox to be large enough
		 	 			 $arguments['height'] += 70;
  			 			 $arguments['width'] += 90;
	
		 				 $output .=   $arguments['height'] . '&width=' . $arguments['width'] . '&file_name=' .  $arguments['filename']; 
		 				 foreach($arguments as $name => $value)
						 {
						 	if (array_search($name, $plugin_settings) === false)
						 	{
					   		 	$output .= '&' . $name . '=' . $value;
						 	}
						 }
						 
						$output .= '" title="' . get_the_title() . '" rel="shadowbox;height=' . $arguments['height'] . ';width=' . $arguments['width'] . '"><img src="' . $thumb . '" alt="Click here To Watch Video"/><br /> Click to Watch!</center></a>' . "\n";
		
				 	}
		
					// The user did not pass a custom height or width. Use the Default Height from config.xml
					if ( !array_key_exists('height', $arguments) )
					{
						//Set padding for the width to allow Shadowbox to be large enough in all browsers
						$width  += 90;
						$height += 70;
			
						$output .=  $height . '&width=' . $width . '&file_name=' .  $arguments['filename'];
						 foreach($arguments as $name => $value)
						 {
						 	if (array_search($name, $plugin_settings) === false)
						 	{
					   		 	$output .= '&' . $name . '=' . $value;
						 	}
						 }
						 $output .= '" title="' . get_the_title() . '" rel="shadowbox;height=' . $height . ';width=' . $width . '"><img src="' . $thumb . '" alt="Click here To Watch Video"/><br /> Click to Watch!</a>' . "\n";

					}	
				}
	
				//There is no Image just print some text to click on
				else
				{	
					//	The user wants to use a custome height and width, use the passed values
					if ( array_key_exists('height', $arguments) )
		 			{
			  			//Set padding for the width to allow Shadowbox to be large enough in all browsers
			  			$arguments['height'] += 70;
 			  			$arguments['width'] += 90;
  
						$output .=  $arguments['height'] . '&width=' . $arguments['width'] . '&file_name=' .  $arguments['filename'];
						 foreach($arguments as $name => $value)
						 {
						 	if (array_search($name, $plugin_settings) === false)
						 	{
					   		 	$output .= '&' . $name . '=' . $value;
						 	}
						 }
						 
						 $output .= '" title="' . get_the_title() . '" rel="shadowbox;height=' . $arguments['height'] . ';width=' . $arguments['width'] . '"> Click to Watch!</a>' . "\n";
		 			}
		
					// The user did not pass a custom height or width. Use the Default Height from config.xml	
					if ( !array_key_exists('height', $arguments) )
					{			
						//Set padding for the width to allow Shadowbox to be large enough
						$width  += 90;
						$height += 70;
			
						$output .=  $height . '&width=' . $width . '&file_name=' .  $arguments['filename'];
						 foreach($arguments as $name => $value)
						 {
						 	if (array_search($name, $plugin_settings) === false)
						 	{
					   		 	$output .= '&' . $name . '=' . $value;
						 	}
						 }
						 
						 $output .= '" title="' . get_the_title() . '" rel="shadowbox;height=' . $height . ';width=' . $width . '">Click To Watch Video</a>' . "\n";
					}
				}
			
		

	}
	
	
	//Return the final link to be used	
	return $output;	
	
		
		}
	
		


} //End Class SimpleFlashVideoPlugin

if (class_exists("SimpleFlashVideoPlugin")) 
	{
		$sfv_plugin = new SimpleFlashVideoPlugin();
	}
	
	
//Initialize the admin panel
if (!function_exists("SimpleFlashVideoPlugin_ap")) 
{
    function SimpleFlashVideoPlugin_ap() 
    {
        global $sfv_plugin;
        if (!isset($sfv_plugin)) 
        {
            return;
     	}
    
    if (function_exists('add_options_page')) 
     {
    	add_options_page('Simple Flash Video Plugin', 'Simple Flash Video Plugin', 9, basename(__FILE__),'printAdminPage');
     }
    
    }   
}

//Actions and Filters   
if (isset($sfv_plugin))
 {
    //Actions
	 add_action('admin_menu', 'SimpleFlashVideoPlugin_ap');
	 add_action('activate_simple-flash-video/simple-flash-video-test.php',  array(&$sfv_plugin, 'init'));
	 add_action('wp_head', array(&$sfv_plugin, 'addHeaderCode'), 1);

	   
    //Filters
    add_filter('the_content', 'FlashVideo_Parse');
    
}
 
?>
